
global MIDAS_VMEAccessServer_Exists
if {![info exists MIDAS_VMEAccessServer_Exists]} {return}

   proc VMEInterfaceReset {} {
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:VMEAccessServer InterfaceReset} msg]
       if {$z != 0} {
           InsertLog "VMEInterfaceReset failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc DefineVMERegister {modname class regname attr} {
       global errorCode errorInfo
       variable Rmsg

       set z [catch {::namespace inscope ::urn:VMEAccessServer  DefineRegister $modname.$regname $class $attr} Rmsg]

       if {$z == 0} {
           set rc [lindex $Rmsg 5]
# InsertLog "DefineVMERegister $modname.$regname $class $attr returned $rc  [format 0x%x $rc]"
#           InsertLog "DefineVMERegister $modname.$regname $class $attr returned $rc  [format 0x%x $rc]"
       } else {
           InsertLog "DefineVMERegister failed: Name=$regname; Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
       }
       return $rc
   }

   proc DeleteVMERegisters {pattern} {
       global errorCode errorInfo
       variable Rmsg

       set z [catch {::namespace inscope ::urn:VMEAccessServer DeleteRegisters $pattern} Rmsg]

       if {$z == 0} {
           set rc [lindex $Rmsg 5]
       } else {
           InsertLog "DeleteVMERegisters failed: Pattern=$pattern; Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
       }
       return $rc
   }

   proc ReadVMERegister {Name} {
       global errorCode errorInfo
       variable Rmsg

       set z [catch {::namespace inscope ::urn:VMEAccessServer ReadRegister $Name} Rmsg]

       if {$z == 0} {
           set rc [lindex $Rmsg 5]
# InsertLog "ReadVMERegister $Name returned $rc  [format 0x%x $rc]"
#           InsertLog "ReadVMERegister $Name returned $rc  [format 0x%x $rc]"
       } else {
           InsertLog "ReadVMERegister failed: Name=$Name; Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
       }
       return $rc
   }

   proc WriteVMERegister {Name Data} {
       global errorCode errorInfo
       variable Wmsg

# InsertLog "WriteVMERegister $Name $Data [format 0x%x $Data]"
       set z [catch {::namespace inscope ::urn:VMEAccessServer WriteRegister $Name $Data} Wmsg]

       if {$z == 0} {
#           InsertLog "WriteVMERegister $Name $Data [format 0x%x $Data] returned: [lindex $Wmsg 5]"
#           InsertLog "WriteVMERegister $Name $Data [format 0x%x $Data]"
       } else {
           InsertLog "WriteVMERegister failed: Name=$Name; Data=$Data; Code= $errorCode; Info= [first [split $errorInfo \n]]"
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
       }
   }

   proc WriteVMERegisters {Name Data} {
       global errorCode errorInfo
       variable Wmsg

# InsertLog "WriteRegisters $Name $Data [format 0x%x $Data]"
       set z [catch {::namespace inscope ::urn:VMEAccessServer WriteRegisters $Name $Data} Wmsg]

       if {$z == 0} {
#           InsertLog "WriteRegisters $Name $Data [format 0x%x $Data] returned: [lindex $Wmsg 5]"
#           InsertLog "WriteRegisters $Name $Data [format 0x%x $Data]"
       } else {
           InsertLog "WriteRegisters failed: Name=$Name; Data=$Data; Code= $errorCode; Info= [first [split $errorInfo \n]]"
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
       }
   }

   proc ReadVMERegisterAttr {Name} {
       global errorCode errorInfo
       variable Rmsg

       set z [catch {::namespace inscope ::urn:VMEAccessServer ReadRegisterAttributes $Name} Rmsg]

       if {$z == 0} {
           set rc [lindex $Rmsg 5]
# InsertLog "ReadRegisterAttributes $Name returned $rc  [format 0x%x $rc]"
#           InsertLog "ReadRegisterAttributes $Name returned $rc  [format 0x%x $rc]"
       } else {
           InsertLog "ReadRegisterAttributes failed: Name=$Name; Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
       }
       return $rc
   }
